#!/usr/bin/perl -w

#===============================================================================
#
#    Created: 03/06/2009 13:22:00
#    Copyright (C) 2009, University of Liverpool.
#    Author: Kevin Ashelford.
#
#    Contact details:
#    Email:   k.ashelford@liv.ac.uk
#    Address: School of Biological Sciences, University of Liverpool, 
#             Biosciences Building, Crown Street, Liverpool, UK. L69 7ZB
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#===============================================================================

use strict;
use warnings;
use Getopt::Std;
use File::Basename;

#///////////////////////////////////////////////////////////////////////////////
#///////////////////////////////////////////////////////////////////////////////

my $_program = basename($0);

sub usage {
	
die <<MESSAGE;
		
usage: $_program
	[-1 coverage infile 1]
	[-2 coverage infile 2]
   or: $_program -h (for help)
	
MESSAGE
}

#///////////////////////////////////////////////////////////////////////////////
#///////////////////////////////////////////////////////////////////////////////

if (!@ARGV) {
	warn "\nERROR: too few arguments\n\n";
	usage;
	}
main(@ARGV);

#///////////////////////////////////////////////////////////////////////////////

# MAIN

sub main {

	if ($ARGV[0] eq "-h") {
		usage;
		}
	
	# Get arguments.
	#===========================================================================
	
	my %options;
	getopts ("1:2:", \%options);
	my $infile1 = $options{1} or usage;
	my $infile2 = $options{2} or usage;
	
	#===========================================================================
	
	
	# Open infile.
	#===========================================================================
	
	
	open(IN1, "$infile1") or die "\nERROR: Could not open $infile1: $!";
	
	
	open(IN2, "$infile2") or die "\nERROR: Could not open $infile2: $!";
	
	while (<IN1>) {
		my $cov1 = $_;
		my $cov2 = <IN2>;
		
		chomp($cov1);
		chomp($cov2);
		
		print "$cov1 $cov2\n";
		
		}
	
	close(IN1) or die "\nERROR: Could not close $infile1: $!";
	close(IN2) or die "\nERROR: Could not close $infile2: $!";
	
	#===========================================================================
	
	
	

	} # End of main.

#///////////////////////////////////////////////////////////////////////////////
#///////////////////////////////////////////////////////////////////////////////
1;

