#!/usr/bin/perl -w
use strict;
use warnings;

#Adjust TSS location based on old and new chromosome coordinate files

my $chr=$ARGV[0]; #chr number
my $infile1=$ARGV[1]; #list for old asm
my $infile2=$ARGV[2]; #bed for a chr
my $outfile=$ARGV[3]; #output new bed file with new tss position

open (LIST, "$infile1") or die "\nERROR: Could not open $infile1\n";
open (BED, "$infile2") or die "\nERROR: Could not open $infile2\n";
open (OUT, ">$outfile") or die "\nERROR: Could not open $outfile\n";


my (@bedf,@bedc,@tssf,@tssc,@list);
#bedf, bedc: array from tss bed file
#tssf,tssc: array of tss data (tss position, tss distance, gene name)


while (<BED>) { #input the tss bed file as a array of array
	my @ts=split();
   if($ts[5] eq '+'){push @bedf,[@ts];push @tssf,$ts[1];}
   if($ts[5] eq '-'){push @bedc,[@ts];push @tssc,$ts[1];}
}


while (<LIST>){
    my @tt=split(/,/,$_);
    if($tt[0]==$chr){push @list,[@tt];}
}

my $N=@list;
my $Lf=@tssf;
my $Lc=@tssc;
my $f=0;
foreach my $i (0..$N-1){
   while(($f<$Lf)&&($tssf[$f]>=$list[$i][2])&&($tssf[$f]<=$list[$i][3])){
      $bedf[$f][1]=$tssf[$f]+$list[$i][1];
      $bedf[$f][2]=$tssf[$f]+$list[$i][1];
      $f++;
    }
    if($f==$Lf){last;}
}

my $c=0;
foreach my $i (0..$N-1){
	while(($c<$Lc)&&($tssc[$c]>=$list[$i][2])&&($tssc[$c]<=$list[$i][3])){
    	$bedc[$c][1]=$tssc[$c]+$list[$i][1];
      $bedc[$c][2]=$tssc[$c]+$list[$i][1];
      $c++;
    }
    if($c==$Lc){last;}
}

#output
foreach my $i (0..$Lf-1){print OUT "@{$bedf[$i]}\n";}
foreach my $i (0..$Lc-1){print OUT "@{$bedc[$i]}\n";}


close (LIST) or die "\nERROR: Could not close $infile1\n";
close (BED) or die "\nERROR: Could not close $infile2\n";
close (OUT) or die "\nERROR: Could not close $outfile\n";