#!/usr/bin/perl
use strict;
use warnings;

#Transfer the csv file of read-head (RH) frequency csv file
#-read frequency csv file
#-RH frequency csv file
#-strand, p: plus strand, m: minus strand


my $infile=$ARGV[0];
my $outfile=$ARGV[1];
open (INPUT, "< $infile") or die "\nERROR: Could not open $infile\n";
open (OUT, "> $outfile") or die "\nERROR: Could not open $outfile\n";

my @coverage=<INPUT>;
chomp(@coverage);
my $readL=50; #Read length is 50bp
my $N=@coverage;
my @tss=(0) x $N;

if ($ARGV[2] eq 'p'){
	for (my $i=0;$i<$N;$i++) {
	  my $ci=$coverage[$i];
	  print OUT "$ci\n";

	  if ($ci!=0){
	    for (my $j=$i;$j<$i+$readL;$j++){
	     $coverage[$j]-=$ci;
	    }
	  }
	}
}
elsif ($ARGV[2] eq 'm'){
	for (my $i=$N-1;$i>=0;$i--) {
	  my $ci=$coverage[$i];
          $tss[$i]=$ci;

	  if ($ci!=0){
	    for (my $j=$i;$j>$i-$readL;$j--){
	     $coverage[$j]-=$ci;
	    }
	  }
	}
         foreach (@tss){
               print OUT "$_\n";
          }
}

close (INPUT) or die "\nERROR: Could not close $infile\n";
close (OUT) or die "\nERROR: Could not close $outfile\n";